
package de.ivu.elect.business.veranstaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.veranstaltung.entity.Teilnahme;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractTeilnahmeEdit {

  @Inject
  protected TeilnahmeDAO dao;

  @Inject
  protected TeilnahmeExtendedDAO extendedDao;

  public void delete(Teilnahme entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Teilnahme entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Teilnahme entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Teilnahme getAttachedEntity(Teilnahme entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Teilnahme getAttachedAndRefreshedEntity(Teilnahme entity) {
    return dao.refresh(entity);
  }
}
